import * as pulumi from "@pulumi/pulumi";
/**
 * Provides an External ID for use in Amazon Web Services IAM Roles. This allows External IDs to be created and deleted.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as wavefront from "@pulumi/wavefront";
 *
 * const externalId = new wavefront.CloudIntegrationAwsExternalId("external_id", {});
 * ```
 *
 * ## Import
 *
 * External IDs can be imported by using the `id`, e.g.:
 *
 * ```sh
 * $ pulumi import wavefront:index/cloudIntegrationAwsExternalId:CloudIntegrationAwsExternalId external_id uGJdkH3k
 * ```
 */
export declare class CloudIntegrationAwsExternalId extends pulumi.CustomResource {
    /**
     * Get an existing CloudIntegrationAwsExternalId resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name: string, id: pulumi.Input<pulumi.ID>, state?: CloudIntegrationAwsExternalIdState, opts?: pulumi.CustomResourceOptions): CloudIntegrationAwsExternalId;
    /**
     * Returns true if the given object is an instance of CloudIntegrationAwsExternalId.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj: any): obj is CloudIntegrationAwsExternalId;
    /**
     * Create a CloudIntegrationAwsExternalId resource with the given unique name, arguments, and options.
     *
     * @param name The _unique_ name of the resource.
     * @param args The arguments to use to populate this resource's properties.
     * @param opts A bag of options that control this resource's behavior.
     */
    constructor(name: string, args?: CloudIntegrationAwsExternalIdArgs, opts?: pulumi.CustomResourceOptions);
}
/**
 * Input properties used for looking up and filtering CloudIntegrationAwsExternalId resources.
 */
export interface CloudIntegrationAwsExternalIdState {
}
/**
 * The set of arguments for constructing a CloudIntegrationAwsExternalId resource.
 */
export interface CloudIntegrationAwsExternalIdArgs {
}
