"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.DerivedMetric = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Wavefront Derived Metric Resource. This allows derived metrics to be created,
 * updated, and deleted.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as wavefront from "@pulumi/wavefront";
 *
 * const derived = new wavefront.DerivedMetric("derived", {
 *     name: "dummy derived metric",
 *     minutes: 5,
 *     query: "aliasMetric(5, \"some.metric\")",
 * });
 * ```
 *
 * ## Import
 *
 * Derived Metrics can be imported by using the `id`, e.g.:
 *
 * ```sh
 * $ pulumi import wavefront:index/derivedMetric:DerivedMetric derived_metric 1577102900578
 * ```
 */
class DerivedMetric extends pulumi.CustomResource {
    /**
     * Get an existing DerivedMetric resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new DerivedMetric(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of DerivedMetric.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === DerivedMetric.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["additionalInformation"] = state ? state.additionalInformation : undefined;
            resourceInputs["minutes"] = state ? state.minutes : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["query"] = state ? state.query : undefined;
            resourceInputs["tags"] = state ? state.tags : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.minutes === undefined) && !opts.urn) {
                throw new Error("Missing required property 'minutes'");
            }
            if ((!args || args.query === undefined) && !opts.urn) {
                throw new Error("Missing required property 'query'");
            }
            resourceInputs["additionalInformation"] = args ? args.additionalInformation : undefined;
            resourceInputs["minutes"] = args ? args.minutes : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["query"] = args ? args.query : undefined;
            resourceInputs["tags"] = args ? args.tags : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(DerivedMetric.__pulumiType, name, resourceInputs, opts);
    }
}
exports.DerivedMetric = DerivedMetric;
/** @internal */
DerivedMetric.__pulumiType = 'wavefront:index/derivedMetric:DerivedMetric';
//# sourceMappingURL=derivedMetric.js.map