import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to get all users in Wavefront.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as wavefront from "@pulumi/wavefront";
 *
 * // Get all users
 * const users = wavefront.getUsers({});
 * ```
 */
export declare function getUsers(opts?: pulumi.InvokeOptions): Promise<GetUsersResult>;
/**
 * A collection of values returned by getUsers.
 */
export interface GetUsersResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * List of all users in Wavefront.
     */
    readonly users: outputs.GetUsersUser[];
}
/**
 * Use this data source to get all users in Wavefront.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as wavefront from "@pulumi/wavefront";
 *
 * // Get all users
 * const users = wavefront.getUsers({});
 * ```
 */
export declare function getUsersOutput(opts?: pulumi.InvokeOutputOptions): pulumi.Output<GetUsersResult>;
